Scriptname DefeatNVNInActionScr extends ReferenceAlias

DefeatMCMscr Property McmConfig auto
DefeatConfig Property RessConfig auto
sslThreadController Controller

Actor Property Player Auto
Bool SpamGuard = False

Function Configure()
	SpamGuard = False
EndFunction

Event OnHit(ObjectReference akAggressor, Form akSrc, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack, bool abBashAttack, bool abHitBlocked)
	If McmConfig.HitInterrupt == false
		return
	Endif

	If SpamGuard
		return
	endif

	Actor Target = self.GetActorRef()
	Actor Aggressor = (akAggressor As Actor)

	If (Target == none || Aggressor == none)
		return
	endif

	SpamGuard = True
	If Target.HasKeyWordString("SexLabActive")
		Controller = SexLabUtil.GetAPI().GetActorController(Target)
		If Controller.VictimRef == none
			return
		endif

		If (Target != Controller.VictimRef)
			RessConfig.MiscSpells[5].Cast(Aggressor, Controller.VictimRef) ; ImmunitySPL
			Controller.EndAnimation()
			Aggressor.PushActorAway(Target, 5.0)
			If (Aggressor.GetFactionReaction(Target) != 1)
				Target.StopCombatAlarm()
				Aggressor.StopCombat()
			Endif
		Endif
	Endif
	Utility.Wait(2.0)
	SpamGuard = False

EndEvent

Event OnCombatStateChanged(Actor akTarget, int aeCombatState)
	If (aeCombatState <= 0)
		return
	endif

	If McmConfig.CombatInterrupt == false
		return
	endif

	Actor Target = self.GetActorRef()

	If (Target == none )
		return
	endif

	If (Target.HasKeyWordString("SexLabActive"))
		Controller = SexLabUtil.GetAPI().GetActorController(Target)
		If (Target != Controller.VictimRef)
			RessConfig.MiscSpells[5].Cast(Target, Controller.VictimRef) ; ImmunitySPL
			Controller.EndAnimation()
		Endif
	Endif

EndEvent

State PlayerVictim ; On PlayerFaction Alias, a hit will always stop a sexlab scene on the player
	Event OnHit(ObjectReference akAggressor, Form akSrc, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack, bool abBashAttack, bool abHitBlocked)
	
		If SpamGuard
			return
		endif	

		Actor Target = self.GetActorRef()
		Actor Aggressor = (akAggressor As Actor)
		If (Target == none || Aggressor == none)
			return
		endif

		
		SpamGuard = True
		If Target.HasKeyWordString("SexLabActive")
			Controller = RessConfig.SexLab.GetActorController(Target)
			RessConfig.MiscSpells[5].Cast(Aggressor, Player) ; ImmunitySPL
			Controller.EndAnimation()
			If (Aggressor.GetFactionReaction(Target) != 1)
				Target.StopCombatAlarm()
				Aggressor.StopCombat()
			Endif
		Endif

		Utility.Wait(2.0)
		SpamGuard = False

	EndEvent

	Event OnCombatStateChanged(Actor akTarget, int aeCombatState)

		If (aeCombatState <= 0)
			return
		endif

		Actor Target = self.GetActorRef()

		If (Target == none)
			return
		endif

		If Target.HasKeyWordString("SexLabActive")
			Controller = SexLabUtil.GetAPI().GetActorController(Target)
			RessConfig.MiscSpells[5].Cast(Target, Controller.VictimRef) ; ImmunitySPL
			Controller.EndAnimation()
		Endif

	EndEvent

EndState

State Inactive
EndState